﻿namespace Kreta.Web.Helpers
{
    public class BootsrapHelper
    {
        public static string GetSizeClasses(int size, bool allSizeSame = false, bool addOffset = false)
        {

            int smallSize = allSizeSame ? size : size * 2 > 12 ? 12 : size * 2;
            return string.Format("col-xs-{0} col-sm-{0} col-md-{1} {2}", smallSize, size, addOffset ? GetOffsetClasses(size, smallSize, allSizeSame) : "");
        }

        private static string GetOffsetClasses(int size, int smallSize, bool allSizeSame = false)
        {
            return string.Format("col-xs-offset-{0} col-sm-offset-{0} col-md-offset-{1}", 12 - smallSize, 12 - size);
        }

        public static string GetOffsetSizeClasses(int size, bool allSizeSame = false)
        {

            int smallSize = allSizeSame ? size : size * 2 > 12 ? 12 : size * 2;
            return string.Format("col-xs-offset-{0} col-sm-offset-{0} col-md-offset-{1}", smallSize, size);
        }
    }
}
