﻿using Kreta.BusinessLogic.Utils;
using Kreta.Core.ConnectionType;
using Kreta.Web.Security;

namespace Kreta.Web.Helpers
{
    public static class ConnectionTypeExtensions
    {
        public static SessionConnectionType GetActiveSessionConnectionType()
            => new SessionConnectionType(ClaimData.SessionId, ClaimData.FelhasznaloId, ClaimData.IntezmenyId, ClaimData.IntezmenyAzonosito, ClaimData.AktivTanevID.Value);

        public static SessionConnectionType GetSessionConnectionType()
            => new SessionConnectionType(ClaimData.SessionId, ClaimData.FelhasznaloId, ClaimData.IntezmenyId, ClaimData.IntezmenyAzonosito, ClaimData.SelectedTanevID.Value);

        public static SessionConnectionType GetNextSessionConnectionType()
            => new SessionConnectionType(ClaimData.SessionId, ClaimData.FelhasznaloId, ClaimData.IntezmenyId, ClaimData.IntezmenyAzonosito, ClaimData.KovTanevID.Value);

        public static OrganizationConnectionType GetOrganizationConnectionType()
            => new OrganizationConnectionType(ClaimData.FelhasznaloId, CommonUtils.GetIntezmenyId(ClaimData.FelhasznaloId), CommonUtils.GetOrganizationIdentifier(), CommonUtils.GetAktualisTanevId(ClaimData.FelhasznaloId));

        public static SystemConnectionType GetSystemConnectionType()
            => new SystemConnectionType(ClaimData.FelhasznaloId, ClaimData.IntezmenyId, ClaimData.IntezmenyAzonosito, ClaimData.AktivTanevID.Value);
    }
}
