﻿using System.Collections.Generic;
using System.Web.Routing;

namespace Kreta.Web.Helpers.Grid
{
    public class GridApiUrl
    {
        public string Route { get; private set; }

        public RouteValueDictionary RouteValues { get; private set; }

        public GridApiUrl(string controller, string action, string route = Constants.RouteKey.ActionApi)
        {
            RouteValues = new RouteValueDictionary();
            RouteValues.Add("controller", controller);
            RouteValues.Add("action", action);
            Route = route;
        }

        public GridApiUrl(string controller, string action, IDictionary<string, string> parameters, string route = Constants.RouteKey.ActionApi) : this(controller, action, route)
        {
            foreach (var item in parameters)
            {
                RouteValues.Add(item.Key, item.Value);
            }
        }
    }
}
