﻿using System.Collections.Generic;
using System.Web.Mvc;
using Kendo.Mvc.UI;

namespace Kreta.Web.Helpers
{
    public static class NotificationExtensions
    {
        public static Kendo.Mvc.UI.Fluent.NotificationBuilder KretaNotification(this HtmlHelper helper, string name, Dictionary<string, object> htmlAttributes = null, bool tip = false)
        {
            var notification = helper.Kendo().Notification()
                .Name(name);

            if (tip)
            {
                notification.Events(e => e.Show("onShow"))
                .Templates(t =>
                {
                    t.Add().Type("info").ClientTemplateID("infoTemplate");
                });

            }
            if (htmlAttributes == null)
            {
                htmlAttributes = new Dictionary<string, object>();
            }

            notification.HtmlAttributes(htmlAttributes);

            return notification;
        }
    }
}
