﻿using System.Collections.Generic;
using System.Text;
using Kreta.Web.Security;

namespace Kreta.Web.Helpers.TabStrip
{
    public class TabStripItemModel
    {
        public string ItemId { get; set; }
        public string ItemName { get; set; }

        public string PartialViewName { get; set; }
        public object Model { get; set; }
        public bool IsActive { get; set; }
        public bool IsETTFDisabled { get; set; }
        public bool IsImportantDisabled { get; set; }

        public string KendoCssClass
        {
            get
            {
                var sb = new StringBuilder();
                if (this.IsActive)
                {
                    sb.Append("k-state-active ");
                }

                // csak ettfverzios tiltas
                //UPDATE: Már vttf verziós tiltás
                //var ettfverzio = ApplicationData.ETTFVerzio;
                var fullKretaVersion = ClaimData.IsFullKretaVerzio;
                if (IsImportantDisabled || (!fullKretaVersion && IsETTFDisabled))
                {
                    sb.Append("k-state-disabled ");
                }
                return sb.ToString();
            }
        }

        public string Area { get; set; }
        public string Controller { get; set; }
        public string Action { get; set; }
        public Dictionary<string, string> RouteParameters { get; set; }
    }
}
